      subroutine matchkk(i,e1,x1,j,e2,x2,iord,plord,ncls,id,sgn,lu)
c----------------------------------------------------------------------c
c Matches two particles into a matrix element
c
c Karol Kolodziej, University of Silesia, karol.kolodziej@us.edu.pl
c 12 April, 2006; modified on 15 Sept. 2006; 16 Feb. 2007
c----------------------------------------------------------------------c

      use extpart
      use intpart

      implicit none

      integer :: i,j,iord,plord(next),ncls,id,sgn,lu,ihel,oifi,oifj,
     &           plij,plii,plio,plig,plif,plict,plin,plie,
     &           pljj,plji,pljo,pljg,pljf,pljct,pljn,plje

      integer :: e1,e2,x1(e1,3),x2(e2,3)



      open(16,file='partcls.tmp',access='direct',form='formatted',
     &                                                     recl=80)
      read(16,1612,rec=i) plij,plii,plio,plig,plif,plict,plin,plie
      read(16,1612,rec=j) pljj,plji,pljo,pljg,pljf,pljct,pljn,plje
 1612 format(6(i3),i24,i3)

      close(16)

      if (plie + plje < next) return

      if (plig == pljg) then
       if (plig == 0) then
        if (plif == 3 .and. pljf == 3) then
         if (plii == -plji) then
          ihel=plin*pljn
          if (ihel /= nhel) then
           write(*,*)'matchkk.f 1: Incorrect No of helicities',ihel
           stop
          end if
          id=id+1
          if (e1 > e2) then
c           call mdcalls(i,j)
           iord=1
          else if (e1 < e2) then
c           call mdcalls(j,i)
           iord=-1
          else
c           call mdcalls(i,j)
           iord=1
          end if
          call backwrite(i,j,ncls,plord,id,sgn)
         end if
        else
         if (plif == pljf) then
          ihel=plin*pljn
          if (ihel /= nhel) then
           write(*,*)'matchkk.f 2: Incorrect No of helicities',ihel
           stop
          end if
          id=id+1
          if (e1 > e2) then
c           call mdcalls(i,j)
           iord=1
          else if (e1 < e2) then
c           call mdcalls(j,i)
           iord=-1
          else
c           call mdcalls(i,j)
           iord=1
          end if
          call backwrite(i,j,ncls,plord,id,sgn)
         end if
        end if
       else
        oifi=plio*plii*plif
        oifj=pljo*plji*pljf
        if (oifi == -oifj) then
         ihel=plin*pljn
         if (ihel /= nhel) then
          write(*,*)'matchkk.f 3: Incorrect No of helicities',ihel
          stop
         end if
         id=id+1
         if (oifi > oifj) then
          if (e1 > e2) then
c           call mdcalls(i,j)
           iord=1
          else if (e1 < e2) then
c           call mdcalls(j,i)
           iord=-1
          else
c           call mdcalls(i,j)
           iord=1
          end if
          call backwrite(i,j,ncls,plord,id,sgn)
         else
          if (e1 > e2) then
c           call mdcalls(j,i)
           iord=-1
          else if (e1 < e2) then
c           call mdcalls(i,j)
           iord=1
          else
c           call mdcalls(j,i)
           iord=-1
          end if
          call backwrite(j,i,ncls,plord,id,sgn)
         end if
        end if
       end if
      end if

      end subroutine matchkk
