      module maxvals

      character(80), parameter :: prvrsn=
c Maximum values of some parameters for
     &         'carlomat, version 4.1 of 28 October, 2008'

      integer, parameter :: 
     &      nffb=48,         ! No of ffb vertices
     &      nbbb=6,          ! No of bbb vertices
     &      nbbbb=8,         ! No of bbbb vertices
     &      ncol=3,          ! No of colours
     &      mxprt=100,       ! Max No of particles in a model
     &      mxepl=12,        ! Max No of external particles
     &      mxipl=100000,    ! Max No of intermediate particles
     &      mxvpl=4,         ! Max No of similar vertices, 
     &                       ! e.g. uua, uuz, uuh, uug
     &      mxncnt=20,       ! Max No of continuation lines,
     &      mxcmdl=1000,     ! Max No of lines in selected routines (e.g. 
     &                       ! mdkk*.f, mmodkk*.f) 
     &      mxcmdb=20,       ! Max No of blocks in selected routines (e.g. 
     &                       ! kin*kk*.f). Relevant for speeding up
     &                       ! their compilation.
     &      mxmap=4          ! Max No of particles in a subsystem whose 
     &                       ! propagator should be mapped.

      end module maxvals

