      subroutine kinkk6(ikin,imom,ecm,m,p,x,ndim,dlips)
 
      use inprms
 
      implicit none
 
      integer, parameter :: nepl=8
      integer :: ikin,imom,ndim
      real(dp) :: ecm,m(nepl),p(0:3,nepl),x(ndim),dlips,v(3),g
      real(dp), dimension(0:3) :: q1,q2,q3,q4
      real(dp) :: sqsl1,sqsl2,sqsl3,sqsl4
      real(dp) :: sqsu1,sqsu2,sqsu3,sqsu4
      real(dp) :: sqs1,sqs2,sqs3,sqs4
      real(dp) :: ds1,ds2,ds3,ds4
      real(dp) :: s1,s2,s3,s4
      real(dp) :: dl1,dl2,dl3,dl4
 
      if (ikin == 101) then
       sqsl1=m(7)+m(8)
       sqsl2=m(6)+sqsl1
       sqsl3=m(3)+m(4)
       sqsl4=sqsl3+m(5)
       if (imom /= 1) then
        q1=p(:,7)+p(:,8)
        q2=p(:,6)+q1
        q3=p(:,3)+p(:,4)
        q4=q3+p(:,5)
       end if
       sqsu2=ecm-sqsl4
       ds2=(sqsu2-sqsl2)*(sqsu2+sqsl2)
       if (imom == 1) then
        s2=ds2*x(2)+sqsl2*sqsl2
       else
        s2=(q2(0)-q2(3))*(q2(0)+q2(3))-q2(1)*q2(1)-q2(2)*q2(2)
       end if
       sqs2=sqrt(s2)
       sqsu1=sqs2-m(6)
       call mapbkk(imom,x(1),q1,mw,gamw,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs2
       call mapbkk(imom,x(4),q4,mmu,gammu,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(5)
       call mapakk(imom,x(3),q3,sqscut,sqsl3,sqsu3,s3,sqs3,ds3)
       call kinff(imom,sqs1,m(7),m(8),x(5:6),p(:,7),p(:,8),dl1)
       call kinff(imom,sqs2,m(6),sqs1,x(7:8),p(:,6),q1,dl2)
       call kinff(imom,sqs3,m(3),m(4),x(9:10),p(:,3),p(:,4),dl3)
       call kinff(imom,sqs4,sqs3,m(5),x(11:12),q3,p(:,5),dl4)
       call kinff(imom,ecm,sqs2,sqs4,x(13:14),q2,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
       end if
      else if (ikin == 102) then
       sqsl1=m(7)+m(8)
       sqsl2=m(6)+sqsl1
       sqsl3=m(3)+m(4)
       sqsl4=sqsl3+m(5)
       if (imom /= 1) then
        q1=p(:,7)+p(:,8)
        q2=p(:,6)+q1
        q3=p(:,3)+p(:,4)
        q4=q3+p(:,5)
       end if
       sqsu2=ecm-sqsl4
       ds2=(sqsu2-sqsl2)*(sqsu2+sqsl2)
       if (imom == 1) then
        s2=ds2*x(2)+sqsl2*sqsl2
       else
        s2=(q2(0)-q2(3))*(q2(0)+q2(3))-q2(1)*q2(1)-q2(2)*q2(2)
       end if
       sqs2=sqrt(s2)
       sqsu1=sqs2-m(6)
       call mapbkk(imom,x(1),q1,mw,gamw,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs2
       call mapbkk(imom,x(4),q4,mmu,gammu,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(5)
       call mapbkk(imom,x(3),q3,mz,gamz,sqsl3,sqsu3,s3,sqs3,ds3)
       call kinff(imom,sqs1,m(7),m(8),x(5:6),p(:,7),p(:,8),dl1)
       call kinff(imom,sqs2,m(6),sqs1,x(7:8),p(:,6),q1,dl2)
       call kinff(imom,sqs3,m(3),m(4),x(9:10),p(:,3),p(:,4),dl3)
       call kinff(imom,sqs4,sqs3,m(5),x(11:12),q3,p(:,5),dl4)
       call kinff(imom,ecm,sqs2,sqs4,x(13:14),q2,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
       end if
      else if (ikin == 103) then
       sqsl1=m(7)+m(8)
       sqsl2=m(6)+sqsl1
       sqsl3=m(3)+m(4)
       sqsl4=sqsl3+m(5)
       if (imom /= 1) then
        q1=p(:,7)+p(:,8)
        q2=p(:,6)+q1
        q3=p(:,3)+p(:,4)
        q4=q3+p(:,5)
       end if
       sqsu2=ecm-sqsl4
       ds2=(sqsu2-sqsl2)*(sqsu2+sqsl2)
       if (imom == 1) then
        s2=ds2*x(2)+sqsl2*sqsl2
       else
        s2=(q2(0)-q2(3))*(q2(0)+q2(3))-q2(1)*q2(1)-q2(2)*q2(2)
       end if
       sqs2=sqrt(s2)
       sqsu1=sqs2-m(6)
       call mapbkk(imom,x(1),q1,mw,gamw,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs2
       call mapbkk(imom,x(4),q4,mmu,gammu,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(5)
       call mapbkk(imom,x(3),q3,mh,gamh,sqsl3,sqsu3,s3,sqs3,ds3)
       call kinff(imom,sqs1,m(7),m(8),x(5:6),p(:,7),p(:,8),dl1)
       call kinff(imom,sqs2,m(6),sqs1,x(7:8),p(:,6),q1,dl2)
       call kinff(imom,sqs3,m(3),m(4),x(9:10),p(:,3),p(:,4),dl3)
       call kinff(imom,sqs4,sqs3,m(5),x(11:12),q3,p(:,5),dl4)
       call kinff(imom,ecm,sqs2,sqs4,x(13:14),q2,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
       end if
      else if (ikin == 104) then
       sqsl1=m(7)+m(8)
       sqsl2=m(6)+sqsl1
       sqsl3=m(3)+m(4)
       sqsl4=sqsl3+m(5)
       if (imom /= 1) then
        q1=p(:,7)+p(:,8)
        q2=p(:,6)+q1
        q3=p(:,3)+p(:,4)
        q4=q3+p(:,5)
       end if
       sqsu2=ecm-sqsl4
       ds2=(sqsu2-sqsl2)*(sqsu2+sqsl2)
       if (imom == 1) then
        s2=ds2*x(2)+sqsl2*sqsl2
       else
        s2=(q2(0)-q2(3))*(q2(0)+q2(3))-q2(1)*q2(1)-q2(2)*q2(2)
       end if
       sqs2=sqrt(s2)
       sqsu1=sqs2-m(6)
       call mapbkk(imom,x(1),q1,mw,gamw,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs2
       call mapbkk(imom,x(4),q4,mmu,gammu,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(5)
       call mapakk(imom,x(3),q3,sqscut,sqsl3,sqsu3,s3,sqs3,ds3)
       call kinff(imom,sqs1,m(7),m(8),x(5:6),p(:,7),p(:,8),dl1)
       call kinff(imom,sqs2,m(6),sqs1,x(7:8),p(:,6),q1,dl2)
       call kinff(imom,sqs3,m(3),m(4),x(9:10),p(:,3),p(:,4),dl3)
       call kinff(imom,sqs4,sqs3,m(5),x(11:12),q3,p(:,5),dl4)
       call kinff(imom,ecm,sqs2,sqs4,x(13:14),q2,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
       end if
      else if (ikin == 105) then
       sqsl1=m(7)+m(8)
       sqsl2=m(6)+sqsl1
       sqsl3=m(3)+m(4)
       sqsl4=sqsl3+m(5)
       if (imom /= 1) then
        q1=p(:,7)+p(:,8)
        q2=p(:,6)+q1
        q3=p(:,3)+p(:,4)
        q4=q3+p(:,5)
       end if
       sqsu2=ecm-sqsl4
       ds2=(sqsu2-sqsl2)*(sqsu2+sqsl2)
       if (imom == 1) then
        s2=ds2*x(2)+sqsl2*sqsl2
       else
        s2=(q2(0)-q2(3))*(q2(0)+q2(3))-q2(1)*q2(1)-q2(2)*q2(2)
       end if
       sqs2=sqrt(s2)
       sqsu1=sqs2-m(6)
       call mapbkk(imom,x(1),q1,mw,gamw,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs2
       call mapbkk(imom,x(4),q4,mmu,gammu,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(5)
       call mapbkk(imom,x(3),q3,mz,gamz,sqsl3,sqsu3,s3,sqs3,ds3)
       call kinff(imom,sqs1,m(7),m(8),x(5:6),p(:,7),p(:,8),dl1)
       call kinff(imom,sqs2,m(6),sqs1,x(7:8),p(:,6),q1,dl2)
       call kinff(imom,sqs3,m(3),m(4),x(9:10),p(:,3),p(:,4),dl3)
       call kinff(imom,sqs4,sqs3,m(5),x(11:12),q3,p(:,5),dl4)
       call kinff(imom,ecm,sqs2,sqs4,x(13:14),q2,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
       end if
      else if (ikin == 106) then
       sqsl1=m(7)+m(8)
       sqsl2=m(6)+sqsl1
       sqsl3=m(3)+m(4)
       sqsl4=sqsl3+m(5)
       if (imom /= 1) then
        q1=p(:,7)+p(:,8)
        q2=p(:,6)+q1
        q3=p(:,3)+p(:,4)
        q4=q3+p(:,5)
       end if
       sqsu2=ecm-sqsl4
       ds2=(sqsu2-sqsl2)*(sqsu2+sqsl2)
       if (imom == 1) then
        s2=ds2*x(2)+sqsl2*sqsl2
       else
        s2=(q2(0)-q2(3))*(q2(0)+q2(3))-q2(1)*q2(1)-q2(2)*q2(2)
       end if
       sqs2=sqrt(s2)
       sqsu1=sqs2-m(6)
       call mapbkk(imom,x(1),q1,mw,gamw,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs2
       call mapbkk(imom,x(4),q4,mmu,gammu,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(5)
       call mapbkk(imom,x(3),q3,mh,gamh,sqsl3,sqsu3,s3,sqs3,ds3)
       call kinff(imom,sqs1,m(7),m(8),x(5:6),p(:,7),p(:,8),dl1)
       call kinff(imom,sqs2,m(6),sqs1,x(7:8),p(:,6),q1,dl2)
       call kinff(imom,sqs3,m(3),m(4),x(9:10),p(:,3),p(:,4),dl3)
       call kinff(imom,sqs4,sqs3,m(5),x(11:12),q3,p(:,5),dl4)
       call kinff(imom,ecm,sqs2,sqs4,x(13:14),q2,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
       end if
      else if (ikin == 107) then
       sqsl1=m(7)+m(8)
       sqsl2=m(6)+sqsl1
       sqsl3=m(3)+m(4)
       sqsl4=sqsl3+m(5)
       if (imom /= 1) then
        q1=p(:,7)+p(:,8)
        q2=p(:,6)+q1
        q3=p(:,3)+p(:,4)
        q4=q3+p(:,5)
       end if
       sqsu2=ecm-sqsl4
       ds2=(sqsu2-sqsl2)*(sqsu2+sqsl2)
       if (imom == 1) then
        s2=ds2*x(2)+sqsl2*sqsl2
       else
        s2=(q2(0)-q2(3))*(q2(0)+q2(3))-q2(1)*q2(1)-q2(2)*q2(2)
       end if
       sqs2=sqrt(s2)
       sqsu1=sqs2-m(6)
       call mapbkk(imom,x(1),q1,mw,gamw,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs2
       call mapbkk(imom,x(4),q4,mmu,gammu,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(5)
       call mapakk(imom,x(3),q3,sqscut,sqsl3,sqsu3,s3,sqs3,ds3)
       call kinff(imom,sqs1,m(7),m(8),x(5:6),p(:,7),p(:,8),dl1)
       call kinff(imom,sqs2,m(6),sqs1,x(7:8),p(:,6),q1,dl2)
       call kinff(imom,sqs3,m(3),m(4),x(9:10),p(:,3),p(:,4),dl3)
       call kinff(imom,sqs4,sqs3,m(5),x(11:12),q3,p(:,5),dl4)
       call kinff(imom,ecm,sqs2,sqs4,x(13:14),q2,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
       end if
      else if (ikin == 108) then
       sqsl1=m(7)+m(8)
       sqsl2=m(6)+sqsl1
       sqsl3=m(3)+m(4)
       sqsl4=sqsl3+m(5)
       if (imom /= 1) then
        q1=p(:,7)+p(:,8)
        q2=p(:,6)+q1
        q3=p(:,3)+p(:,4)
        q4=q3+p(:,5)
       end if
       sqsu2=ecm-sqsl4
       ds2=(sqsu2-sqsl2)*(sqsu2+sqsl2)
       if (imom == 1) then
        s2=ds2*x(2)+sqsl2*sqsl2
       else
        s2=(q2(0)-q2(3))*(q2(0)+q2(3))-q2(1)*q2(1)-q2(2)*q2(2)
       end if
       sqs2=sqrt(s2)
       sqsu1=sqs2-m(6)
       call mapbkk(imom,x(1),q1,mw,gamw,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs2
       call mapbkk(imom,x(4),q4,mmu,gammu,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(5)
       call mapbkk(imom,x(3),q3,mz,gamz,sqsl3,sqsu3,s3,sqs3,ds3)
       call kinff(imom,sqs1,m(7),m(8),x(5:6),p(:,7),p(:,8),dl1)
       call kinff(imom,sqs2,m(6),sqs1,x(7:8),p(:,6),q1,dl2)
       call kinff(imom,sqs3,m(3),m(4),x(9:10),p(:,3),p(:,4),dl3)
       call kinff(imom,sqs4,sqs3,m(5),x(11:12),q3,p(:,5),dl4)
       call kinff(imom,ecm,sqs2,sqs4,x(13:14),q2,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
       end if
      else if (ikin == 109) then
       sqsl1=m(7)+m(8)
       sqsl2=m(6)+sqsl1
       sqsl3=m(3)+m(4)
       sqsl4=sqsl3+m(5)
       if (imom /= 1) then
        q1=p(:,7)+p(:,8)
        q2=p(:,6)+q1
        q3=p(:,3)+p(:,4)
        q4=q3+p(:,5)
       end if
       sqsu2=ecm-sqsl4
       ds2=(sqsu2-sqsl2)*(sqsu2+sqsl2)
       if (imom == 1) then
        s2=ds2*x(2)+sqsl2*sqsl2
       else
        s2=(q2(0)-q2(3))*(q2(0)+q2(3))-q2(1)*q2(1)-q2(2)*q2(2)
       end if
       sqs2=sqrt(s2)
       sqsu1=sqs2-m(6)
       call mapbkk(imom,x(1),q1,mw,gamw,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs2
       call mapbkk(imom,x(4),q4,mmu,gammu,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(5)
       call mapbkk(imom,x(3),q3,mh,gamh,sqsl3,sqsu3,s3,sqs3,ds3)
       call kinff(imom,sqs1,m(7),m(8),x(5:6),p(:,7),p(:,8),dl1)
       call kinff(imom,sqs2,m(6),sqs1,x(7:8),p(:,6),q1,dl2)
       call kinff(imom,sqs3,m(3),m(4),x(9:10),p(:,3),p(:,4),dl3)
       call kinff(imom,sqs4,sqs3,m(5),x(11:12),q3,p(:,5),dl4)
       call kinff(imom,ecm,sqs2,sqs4,x(13:14),q2,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
       end if
      else if (ikin == 110) then
       sqsl1=m(7)+m(8)
       sqsl2=m(6)+sqsl1
       sqsl3=m(3)+m(4)
       sqsl4=sqsl3+m(5)
       if (imom /= 1) then
        q1=p(:,7)+p(:,8)
        q2=p(:,6)+q1
        q3=p(:,3)+p(:,4)
        q4=q3+p(:,5)
       end if
       sqsu2=ecm-sqsl4
       ds2=(sqsu2-sqsl2)*(sqsu2+sqsl2)
       if (imom == 1) then
        s2=ds2*x(2)+sqsl2*sqsl2
       else
        s2=(q2(0)-q2(3))*(q2(0)+q2(3))-q2(1)*q2(1)-q2(2)*q2(2)
       end if
       sqs2=sqrt(s2)
       sqsu1=sqs2-m(6)
       call mapbkk(imom,x(1),q1,mw,gamw,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs2
       call mapbkk(imom,x(4),q4,mmu,gammu,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(5)
       call mapakk(imom,x(3),q3,sqscut,sqsl3,sqsu3,s3,sqs3,ds3)
       call kinff(imom,sqs1,m(7),m(8),x(5:6),p(:,7),p(:,8),dl1)
       call kinff(imom,sqs2,m(6),sqs1,x(7:8),p(:,6),q1,dl2)
       call kinff(imom,sqs3,m(3),m(4),x(9:10),p(:,3),p(:,4),dl3)
       call kinff(imom,sqs4,sqs3,m(5),x(11:12),q3,p(:,5),dl4)
       call kinff(imom,ecm,sqs2,sqs4,x(13:14),q2,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
       end if
      else if (ikin == 111) then
       sqsl1=m(7)+m(8)
       sqsl2=m(6)+sqsl1
       sqsl3=m(3)+m(4)
       sqsl4=sqsl3+m(5)
       if (imom /= 1) then
        q1=p(:,7)+p(:,8)
        q2=p(:,6)+q1
        q3=p(:,3)+p(:,4)
        q4=q3+p(:,5)
       end if
       sqsu2=ecm-sqsl4
       ds2=(sqsu2-sqsl2)*(sqsu2+sqsl2)
       if (imom == 1) then
        s2=ds2*x(2)+sqsl2*sqsl2
       else
        s2=(q2(0)-q2(3))*(q2(0)+q2(3))-q2(1)*q2(1)-q2(2)*q2(2)
       end if
       sqs2=sqrt(s2)
       sqsu1=sqs2-m(6)
       call mapbkk(imom,x(1),q1,mw,gamw,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs2
       call mapbkk(imom,x(4),q4,mmu,gammu,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(5)
       call mapbkk(imom,x(3),q3,mz,gamz,sqsl3,sqsu3,s3,sqs3,ds3)
       call kinff(imom,sqs1,m(7),m(8),x(5:6),p(:,7),p(:,8),dl1)
       call kinff(imom,sqs2,m(6),sqs1,x(7:8),p(:,6),q1,dl2)
       call kinff(imom,sqs3,m(3),m(4),x(9:10),p(:,3),p(:,4),dl3)
       call kinff(imom,sqs4,sqs3,m(5),x(11:12),q3,p(:,5),dl4)
       call kinff(imom,ecm,sqs2,sqs4,x(13:14),q2,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
       end if
      else if (ikin == 112) then
       sqsl1=m(7)+m(8)
       sqsl2=m(6)+sqsl1
       sqsl3=m(3)+m(4)
       sqsl4=sqsl3+m(5)
       if (imom /= 1) then
        q1=p(:,7)+p(:,8)
        q2=p(:,6)+q1
        q3=p(:,3)+p(:,4)
        q4=q3+p(:,5)
       end if
       sqsu2=ecm-sqsl4
       ds2=(sqsu2-sqsl2)*(sqsu2+sqsl2)
       if (imom == 1) then
        s2=ds2*x(2)+sqsl2*sqsl2
       else
        s2=(q2(0)-q2(3))*(q2(0)+q2(3))-q2(1)*q2(1)-q2(2)*q2(2)
       end if
       sqs2=sqrt(s2)
       sqsu1=sqs2-m(6)
       call mapbkk(imom,x(1),q1,mw,gamw,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs2
       call mapbkk(imom,x(4),q4,mmu,gammu,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(5)
       call mapbkk(imom,x(3),q3,mh,gamh,sqsl3,sqsu3,s3,sqs3,ds3)
       call kinff(imom,sqs1,m(7),m(8),x(5:6),p(:,7),p(:,8),dl1)
       call kinff(imom,sqs2,m(6),sqs1,x(7:8),p(:,6),q1,dl2)
       call kinff(imom,sqs3,m(3),m(4),x(9:10),p(:,3),p(:,4),dl3)
       call kinff(imom,sqs4,sqs3,m(5),x(11:12),q3,p(:,5),dl4)
       call kinff(imom,ecm,sqs2,sqs4,x(13:14),q2,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
       end if
      else if (ikin == 113) then
       sqsl1=m(7)+m(8)
       sqsl2=m(6)+sqsl1
       sqsl3=m(3)+m(4)
       sqsl4=sqsl3+m(5)
       if (imom /= 1) then
        q1=p(:,7)+p(:,8)
        q2=p(:,6)+q1
        q3=p(:,3)+p(:,4)
        q4=q3+p(:,5)
       end if
       sqsu2=ecm-sqsl4
       ds2=(sqsu2-sqsl2)*(sqsu2+sqsl2)
       if (imom == 1) then
        s2=ds2*x(2)+sqsl2*sqsl2
       else
        s2=(q2(0)-q2(3))*(q2(0)+q2(3))-q2(1)*q2(1)-q2(2)*q2(2)
       end if
       sqs2=sqrt(s2)
       sqsu1=sqs2-m(6)
       call mapbkk(imom,x(1),q1,mw,gamw,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs2
       call mapbkk(imom,x(4),q4,mmu,gammu,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(5)
       call mapakk(imom,x(3),q3,sqscut,sqsl3,sqsu3,s3,sqs3,ds3)
       call kinff(imom,sqs1,m(7),m(8),x(5:6),p(:,7),p(:,8),dl1)
       call kinff(imom,sqs2,m(6),sqs1,x(7:8),p(:,6),q1,dl2)
       call kinff(imom,sqs3,m(3),m(4),x(9:10),p(:,3),p(:,4),dl3)
       call kinff(imom,sqs4,sqs3,m(5),x(11:12),q3,p(:,5),dl4)
       call kinff(imom,ecm,sqs2,sqs4,x(13:14),q2,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
       end if
      else if (ikin == 114) then
       sqsl1=m(7)+m(8)
       sqsl2=m(6)+sqsl1
       sqsl3=m(3)+m(4)
       sqsl4=sqsl3+m(5)
       if (imom /= 1) then
        q1=p(:,7)+p(:,8)
        q2=p(:,6)+q1
        q3=p(:,3)+p(:,4)
        q4=q3+p(:,5)
       end if
       sqsu2=ecm-sqsl4
       ds2=(sqsu2-sqsl2)*(sqsu2+sqsl2)
       if (imom == 1) then
        s2=ds2*x(2)+sqsl2*sqsl2
       else
        s2=(q2(0)-q2(3))*(q2(0)+q2(3))-q2(1)*q2(1)-q2(2)*q2(2)
       end if
       sqs2=sqrt(s2)
       sqsu1=sqs2-m(6)
       call mapbkk(imom,x(1),q1,mw,gamw,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs2
       call mapbkk(imom,x(4),q4,mmu,gammu,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(5)
       call mapbkk(imom,x(3),q3,mz,gamz,sqsl3,sqsu3,s3,sqs3,ds3)
       call kinff(imom,sqs1,m(7),m(8),x(5:6),p(:,7),p(:,8),dl1)
       call kinff(imom,sqs2,m(6),sqs1,x(7:8),p(:,6),q1,dl2)
       call kinff(imom,sqs3,m(3),m(4),x(9:10),p(:,3),p(:,4),dl3)
       call kinff(imom,sqs4,sqs3,m(5),x(11:12),q3,p(:,5),dl4)
       call kinff(imom,ecm,sqs2,sqs4,x(13:14),q2,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
       end if
      else if (ikin == 115) then
       sqsl1=m(7)+m(8)
       sqsl2=m(6)+sqsl1
       sqsl3=m(3)+m(4)
       sqsl4=sqsl3+m(5)
       if (imom /= 1) then
        q1=p(:,7)+p(:,8)
        q2=p(:,6)+q1
        q3=p(:,3)+p(:,4)
        q4=q3+p(:,5)
       end if
       sqsu2=ecm-sqsl4
       ds2=(sqsu2-sqsl2)*(sqsu2+sqsl2)
       if (imom == 1) then
        s2=ds2*x(2)+sqsl2*sqsl2
       else
        s2=(q2(0)-q2(3))*(q2(0)+q2(3))-q2(1)*q2(1)-q2(2)*q2(2)
       end if
       sqs2=sqrt(s2)
       sqsu1=sqs2-m(6)
       call mapbkk(imom,x(1),q1,mw,gamw,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs2
       call mapbkk(imom,x(4),q4,mmu,gammu,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(5)
       call mapbkk(imom,x(3),q3,mh,gamh,sqsl3,sqsu3,s3,sqs3,ds3)
       call kinff(imom,sqs1,m(7),m(8),x(5:6),p(:,7),p(:,8),dl1)
       call kinff(imom,sqs2,m(6),sqs1,x(7:8),p(:,6),q1,dl2)
       call kinff(imom,sqs3,m(3),m(4),x(9:10),p(:,3),p(:,4),dl3)
       call kinff(imom,sqs4,sqs3,m(5),x(11:12),q3,p(:,5),dl4)
       call kinff(imom,ecm,sqs2,sqs4,x(13:14),q2,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
       end if
      else if (ikin == 116) then
       sqsl1=m(7)+m(8)
       sqsl2=m(6)+sqsl1
       sqsl3=m(3)+m(4)
       sqsl4=sqsl3+m(5)
       if (imom /= 1) then
        q1=p(:,7)+p(:,8)
        q2=p(:,6)+q1
        q3=p(:,3)+p(:,4)
        q4=q3+p(:,5)
       end if
       sqsu2=ecm-sqsl4
       ds2=(sqsu2-sqsl2)*(sqsu2+sqsl2)
       if (imom == 1) then
        s2=ds2*x(2)+sqsl2*sqsl2
       else
        s2=(q2(0)-q2(3))*(q2(0)+q2(3))-q2(1)*q2(1)-q2(2)*q2(2)
       end if
       sqs2=sqrt(s2)
       sqsu1=sqs2-m(6)
       call mapbkk(imom,x(1),q1,mw,gamw,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs2
       call mapbkk(imom,x(4),q4,mmu,gammu,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(5)
       call mapakk(imom,x(3),q3,sqscut,sqsl3,sqsu3,s3,sqs3,ds3)
       call kinff(imom,sqs1,m(7),m(8),x(5:6),p(:,7),p(:,8),dl1)
       call kinff(imom,sqs2,m(6),sqs1,x(7:8),p(:,6),q1,dl2)
       call kinff(imom,sqs3,m(3),m(4),x(9:10),p(:,3),p(:,4),dl3)
       call kinff(imom,sqs4,sqs3,m(5),x(11:12),q3,p(:,5),dl4)
       call kinff(imom,ecm,sqs2,sqs4,x(13:14),q2,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
       end if
      else if (ikin == 117) then
       sqsl1=m(7)+m(8)
       sqsl2=m(6)+sqsl1
       sqsl3=m(3)+m(4)
       sqsl4=sqsl3+m(5)
       if (imom /= 1) then
        q1=p(:,7)+p(:,8)
        q2=p(:,6)+q1
        q3=p(:,3)+p(:,4)
        q4=q3+p(:,5)
       end if
       sqsu2=ecm-sqsl4
       ds2=(sqsu2-sqsl2)*(sqsu2+sqsl2)
       if (imom == 1) then
        s2=ds2*x(2)+sqsl2*sqsl2
       else
        s2=(q2(0)-q2(3))*(q2(0)+q2(3))-q2(1)*q2(1)-q2(2)*q2(2)
       end if
       sqs2=sqrt(s2)
       sqsu1=sqs2-m(6)
       call mapbkk(imom,x(1),q1,mw,gamw,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs2
       call mapbkk(imom,x(4),q4,mmu,gammu,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(5)
       call mapbkk(imom,x(3),q3,mz,gamz,sqsl3,sqsu3,s3,sqs3,ds3)
       call kinff(imom,sqs1,m(7),m(8),x(5:6),p(:,7),p(:,8),dl1)
       call kinff(imom,sqs2,m(6),sqs1,x(7:8),p(:,6),q1,dl2)
       call kinff(imom,sqs3,m(3),m(4),x(9:10),p(:,3),p(:,4),dl3)
       call kinff(imom,sqs4,sqs3,m(5),x(11:12),q3,p(:,5),dl4)
       call kinff(imom,ecm,sqs2,sqs4,x(13:14),q2,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
       end if
      else if (ikin == 118) then
       sqsl1=m(7)+m(8)
       sqsl2=m(6)+sqsl1
       sqsl3=m(3)+m(4)
       sqsl4=sqsl3+m(5)
       if (imom /= 1) then
        q1=p(:,7)+p(:,8)
        q2=p(:,6)+q1
        q3=p(:,3)+p(:,4)
        q4=q3+p(:,5)
       end if
       sqsu2=ecm-sqsl4
       ds2=(sqsu2-sqsl2)*(sqsu2+sqsl2)
       if (imom == 1) then
        s2=ds2*x(2)+sqsl2*sqsl2
       else
        s2=(q2(0)-q2(3))*(q2(0)+q2(3))-q2(1)*q2(1)-q2(2)*q2(2)
       end if
       sqs2=sqrt(s2)
       sqsu1=sqs2-m(6)
       call mapbkk(imom,x(1),q1,mw,gamw,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs2
       call mapbkk(imom,x(4),q4,mmu,gammu,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(5)
       call mapbkk(imom,x(3),q3,mh,gamh,sqsl3,sqsu3,s3,sqs3,ds3)
       call kinff(imom,sqs1,m(7),m(8),x(5:6),p(:,7),p(:,8),dl1)
       call kinff(imom,sqs2,m(6),sqs1,x(7:8),p(:,6),q1,dl2)
       call kinff(imom,sqs3,m(3),m(4),x(9:10),p(:,3),p(:,4),dl3)
       call kinff(imom,sqs4,sqs3,m(5),x(11:12),q3,p(:,5),dl4)
       call kinff(imom,ecm,sqs2,sqs4,x(13:14),q2,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
       end if
      else if (ikin == 119) then
       sqsl1=m(7)+m(8)
       sqsl2=m(6)+sqsl1
       sqsl3=m(3)+m(4)
       sqsl4=sqsl3+m(5)
       if (imom /= 1) then
        q1=p(:,7)+p(:,8)
        q2=p(:,6)+q1
        q3=p(:,3)+p(:,4)
        q4=q3+p(:,5)
       end if
       sqsu2=ecm-sqsl4
       ds2=(sqsu2-sqsl2)*(sqsu2+sqsl2)
       if (imom == 1) then
        s2=ds2*x(2)+sqsl2*sqsl2
       else
        s2=(q2(0)-q2(3))*(q2(0)+q2(3))-q2(1)*q2(1)-q2(2)*q2(2)
       end if
       sqs2=sqrt(s2)
       sqsu1=sqs2-m(6)
       call mapbkk(imom,x(1),q1,mw,gamw,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs2
       call mapbkk(imom,x(4),q4,mmu,gammu,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(5)
       call mapakk(imom,x(3),q3,sqscut,sqsl3,sqsu3,s3,sqs3,ds3)
       call kinff(imom,sqs1,m(7),m(8),x(5:6),p(:,7),p(:,8),dl1)
       call kinff(imom,sqs2,m(6),sqs1,x(7:8),p(:,6),q1,dl2)
       call kinff(imom,sqs3,m(3),m(4),x(9:10),p(:,3),p(:,4),dl3)
       call kinff(imom,sqs4,sqs3,m(5),x(11:12),q3,p(:,5),dl4)
       call kinff(imom,ecm,sqs2,sqs4,x(13:14),q2,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
       end if
      else if (ikin == 120) then
       sqsl1=m(7)+m(8)
       sqsl2=m(6)+sqsl1
       sqsl3=m(3)+m(4)
       sqsl4=sqsl3+m(5)
       if (imom /= 1) then
        q1=p(:,7)+p(:,8)
        q2=p(:,6)+q1
        q3=p(:,3)+p(:,4)
        q4=q3+p(:,5)
       end if
       sqsu2=ecm-sqsl4
       ds2=(sqsu2-sqsl2)*(sqsu2+sqsl2)
       if (imom == 1) then
        s2=ds2*x(2)+sqsl2*sqsl2
       else
        s2=(q2(0)-q2(3))*(q2(0)+q2(3))-q2(1)*q2(1)-q2(2)*q2(2)
       end if
       sqs2=sqrt(s2)
       sqsu1=sqs2-m(6)
       call mapbkk(imom,x(1),q1,mw,gamw,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs2
       call mapbkk(imom,x(4),q4,mmu,gammu,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(5)
       call mapbkk(imom,x(3),q3,mz,gamz,sqsl3,sqsu3,s3,sqs3,ds3)
       call kinff(imom,sqs1,m(7),m(8),x(5:6),p(:,7),p(:,8),dl1)
       call kinff(imom,sqs2,m(6),sqs1,x(7:8),p(:,6),q1,dl2)
       call kinff(imom,sqs3,m(3),m(4),x(9:10),p(:,3),p(:,4),dl3)
       call kinff(imom,sqs4,sqs3,m(5),x(11:12),q3,p(:,5),dl4)
       call kinff(imom,ecm,sqs2,sqs4,x(13:14),q2,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
       end if
      end if
 
      end
