      subroutine kinkk2(ikin,imom,ecm,m,p,x,ndim,dlips)
 
      use inprms
 
      implicit none
 
      integer, parameter :: nepl=8
      integer :: ikin,imom,ndim
      real(dp) :: ecm,m(nepl),p(0:3,nepl),x(ndim),dlips,v(3),g
      real(dp), dimension(0:3) :: q1,q2,q3,q4
      real(dp) :: sqsl1,sqsl2,sqsl3,sqsl4
      real(dp) :: sqsu1,sqsu2,sqsu3,sqsu4
      real(dp) :: sqs1,sqs2,sqs3,sqs4
      real(dp) :: ds1,ds2,ds3,ds4
      real(dp) :: s1,s2,s3,s4
      real(dp) :: dl1,dl2,dl3,dl4
 
      if (ikin == 21) then
       sqsl1=m(6)+m(5)
       sqsl2=sqsl1+m(8)
       sqsl3=m(7)+sqsl2
       sqsl4=m(3)+m(4)
       if (imom /= 1) then
        q1=p(:,6)+p(:,5)
        q2=q1+p(:,8)
        q3=p(:,7)+q2
        q4=p(:,3)+p(:,4)
       end if
       sqsu3=ecm-sqsl4
       call mapbkk(imom,x(3),q3,mh,gamh,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(7)
       call mapbkk(imom,x(2),q2,md,gamd,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(8)
       call mapbkk(imom,x(1),q1,mw,gamw,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs3
       call mapbkk(imom,x(4),q4,mh,gamh,sqsl4,sqsu4,s4,sqs4,ds4)
       call kinff(imom,sqs1,m(6),m(5),x(5:6),p(:,6),p(:,5),dl1)
       call kinff(imom,sqs2,sqs1,m(8),x(7:8),q1,p(:,8),dl2)
       call kinff(imom,sqs3,m(7),sqs2,x(9:10),p(:,7),q2,dl3)
       call kinff(imom,sqs4,m(3),m(4),x(11:12),p(:,3),p(:,4),dl4)
       call kinff(imom,ecm,sqs3,sqs4,x(13:14),q3,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,5))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,8))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,8))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
       end if
      else if (ikin == 22) then
       sqsl1=m(6)+m(5)
       sqsl2=m(7)+m(8)
       sqsl3=sqsl1+sqsl2
       sqsl4=m(3)+m(4)
       if (imom /= 1) then
        q1=p(:,6)+p(:,5)
        q2=p(:,7)+p(:,8)
        q3=q1+q2
        q4=p(:,3)+p(:,4)
       end if
       sqsu3=ecm-sqsl4
       call mapakk(imom,x(3),q3,sqscut,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-sqsl1
       call mapbkk(imom,x(2),q2,mw,gamw,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs3-sqs2
       call mapbkk(imom,x(1),q1,mw,gamw,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs3
       call mapakk(imom,x(4),q4,sqscut,sqsl4,sqsu4,s4,sqs4,ds4)
       call kinff(imom,sqs1,m(6),m(5),x(5:6),p(:,6),p(:,5),dl1)
       call kinff(imom,sqs2,m(7),m(8),x(7:8),p(:,7),p(:,8),dl2)
       call kinff(imom,sqs3,sqs1,sqs2,x(9:10),q1,q2,dl3)
       call kinff(imom,sqs4,m(3),m(4),x(11:12),p(:,3),p(:,4),dl4)
       call kinff(imom,ecm,sqs3,sqs4,x(13:14),q3,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,5))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
       end if
      else if (ikin == 23) then
       sqsl1=m(6)+m(5)
       sqsl2=m(7)+m(8)
       sqsl3=sqsl1+sqsl2
       sqsl4=m(3)+m(4)
       if (imom /= 1) then
        q1=p(:,6)+p(:,5)
        q2=p(:,7)+p(:,8)
        q3=q1+q2
        q4=p(:,3)+p(:,4)
       end if
       sqsu3=ecm-sqsl4
       call mapakk(imom,x(3),q3,sqscut,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-sqsl1
       call mapbkk(imom,x(2),q2,mw,gamw,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs3-sqs2
       call mapbkk(imom,x(1),q1,mw,gamw,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs3
       call mapbkk(imom,x(4),q4,mz,gamz,sqsl4,sqsu4,s4,sqs4,ds4)
       call kinff(imom,sqs1,m(6),m(5),x(5:6),p(:,6),p(:,5),dl1)
       call kinff(imom,sqs2,m(7),m(8),x(7:8),p(:,7),p(:,8),dl2)
       call kinff(imom,sqs3,sqs1,sqs2,x(9:10),q1,q2,dl3)
       call kinff(imom,sqs4,m(3),m(4),x(11:12),p(:,3),p(:,4),dl4)
       call kinff(imom,ecm,sqs3,sqs4,x(13:14),q3,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,5))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
       end if
      else if (ikin == 24) then
       sqsl1=m(6)+m(5)
       sqsl2=m(7)+m(8)
       sqsl3=sqsl1+sqsl2
       sqsl4=m(3)+m(4)
       if (imom /= 1) then
        q1=p(:,6)+p(:,5)
        q2=p(:,7)+p(:,8)
        q3=q1+q2
        q4=p(:,3)+p(:,4)
       end if
       sqsu3=ecm-sqsl4
       call mapakk(imom,x(3),q3,sqscut,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-sqsl1
       call mapbkk(imom,x(2),q2,mw,gamw,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs3-sqs2
       call mapbkk(imom,x(1),q1,mw,gamw,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs3
       call mapbkk(imom,x(4),q4,mh,gamh,sqsl4,sqsu4,s4,sqs4,ds4)
       call kinff(imom,sqs1,m(6),m(5),x(5:6),p(:,6),p(:,5),dl1)
       call kinff(imom,sqs2,m(7),m(8),x(7:8),p(:,7),p(:,8),dl2)
       call kinff(imom,sqs3,sqs1,sqs2,x(9:10),q1,q2,dl3)
       call kinff(imom,sqs4,m(3),m(4),x(11:12),p(:,3),p(:,4),dl4)
       call kinff(imom,ecm,sqs3,sqs4,x(13:14),q3,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,5))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
       end if
      else if (ikin == 25) then
       sqsl1=m(6)+m(5)
       sqsl2=m(7)+m(8)
       sqsl3=sqsl1+sqsl2
       sqsl4=m(3)+m(4)
       if (imom /= 1) then
        q1=p(:,6)+p(:,5)
        q2=p(:,7)+p(:,8)
        q3=q1+q2
        q4=p(:,3)+p(:,4)
       end if
       sqsu3=ecm-sqsl4
       call mapbkk(imom,x(3),q3,mz,gamz,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-sqsl1
       call mapbkk(imom,x(2),q2,mw,gamw,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs3-sqs2
       call mapbkk(imom,x(1),q1,mw,gamw,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs3
       call mapakk(imom,x(4),q4,sqscut,sqsl4,sqsu4,s4,sqs4,ds4)
       call kinff(imom,sqs1,m(6),m(5),x(5:6),p(:,6),p(:,5),dl1)
       call kinff(imom,sqs2,m(7),m(8),x(7:8),p(:,7),p(:,8),dl2)
       call kinff(imom,sqs3,sqs1,sqs2,x(9:10),q1,q2,dl3)
       call kinff(imom,sqs4,m(3),m(4),x(11:12),p(:,3),p(:,4),dl4)
       call kinff(imom,ecm,sqs3,sqs4,x(13:14),q3,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,5))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
       end if
      else if (ikin == 26) then
       sqsl1=m(6)+m(5)
       sqsl2=m(7)+m(8)
       sqsl3=sqsl1+sqsl2
       sqsl4=m(3)+m(4)
       if (imom /= 1) then
        q1=p(:,6)+p(:,5)
        q2=p(:,7)+p(:,8)
        q3=q1+q2
        q4=p(:,3)+p(:,4)
       end if
       sqsu3=ecm-sqsl4
       call mapbkk(imom,x(3),q3,mz,gamz,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-sqsl1
       call mapbkk(imom,x(2),q2,mw,gamw,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs3-sqs2
       call mapbkk(imom,x(1),q1,mw,gamw,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs3
       call mapbkk(imom,x(4),q4,mz,gamz,sqsl4,sqsu4,s4,sqs4,ds4)
       call kinff(imom,sqs1,m(6),m(5),x(5:6),p(:,6),p(:,5),dl1)
       call kinff(imom,sqs2,m(7),m(8),x(7:8),p(:,7),p(:,8),dl2)
       call kinff(imom,sqs3,sqs1,sqs2,x(9:10),q1,q2,dl3)
       call kinff(imom,sqs4,m(3),m(4),x(11:12),p(:,3),p(:,4),dl4)
       call kinff(imom,ecm,sqs3,sqs4,x(13:14),q3,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,5))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
       end if
      else if (ikin == 27) then
       sqsl1=m(6)+m(5)
       sqsl2=m(7)+m(8)
       sqsl3=sqsl1+sqsl2
       sqsl4=m(3)+m(4)
       if (imom /= 1) then
        q1=p(:,6)+p(:,5)
        q2=p(:,7)+p(:,8)
        q3=q1+q2
        q4=p(:,3)+p(:,4)
       end if
       sqsu3=ecm-sqsl4
       call mapbkk(imom,x(3),q3,mz,gamz,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-sqsl1
       call mapbkk(imom,x(2),q2,mw,gamw,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs3-sqs2
       call mapbkk(imom,x(1),q1,mw,gamw,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs3
       call mapbkk(imom,x(4),q4,mh,gamh,sqsl4,sqsu4,s4,sqs4,ds4)
       call kinff(imom,sqs1,m(6),m(5),x(5:6),p(:,6),p(:,5),dl1)
       call kinff(imom,sqs2,m(7),m(8),x(7:8),p(:,7),p(:,8),dl2)
       call kinff(imom,sqs3,sqs1,sqs2,x(9:10),q1,q2,dl3)
       call kinff(imom,sqs4,m(3),m(4),x(11:12),p(:,3),p(:,4),dl4)
       call kinff(imom,ecm,sqs3,sqs4,x(13:14),q3,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,5))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
       end if
      else if (ikin == 28) then
       sqsl1=m(6)+m(5)
       sqsl2=m(7)+m(8)
       sqsl3=sqsl1+sqsl2
       sqsl4=m(3)+m(4)
       if (imom /= 1) then
        q1=p(:,6)+p(:,5)
        q2=p(:,7)+p(:,8)
        q3=q1+q2
        q4=p(:,3)+p(:,4)
       end if
       sqsu3=ecm-sqsl4
       call mapbkk(imom,x(3),q3,mh,gamh,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-sqsl1
       call mapbkk(imom,x(2),q2,mw,gamw,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs3-sqs2
       call mapbkk(imom,x(1),q1,mw,gamw,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs3
       call mapakk(imom,x(4),q4,sqscut,sqsl4,sqsu4,s4,sqs4,ds4)
       call kinff(imom,sqs1,m(6),m(5),x(5:6),p(:,6),p(:,5),dl1)
       call kinff(imom,sqs2,m(7),m(8),x(7:8),p(:,7),p(:,8),dl2)
       call kinff(imom,sqs3,sqs1,sqs2,x(9:10),q1,q2,dl3)
       call kinff(imom,sqs4,m(3),m(4),x(11:12),p(:,3),p(:,4),dl4)
       call kinff(imom,ecm,sqs3,sqs4,x(13:14),q3,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,5))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
       end if
      else if (ikin == 29) then
       sqsl1=m(6)+m(5)
       sqsl2=m(7)+m(8)
       sqsl3=sqsl1+sqsl2
       sqsl4=m(3)+m(4)
       if (imom /= 1) then
        q1=p(:,6)+p(:,5)
        q2=p(:,7)+p(:,8)
        q3=q1+q2
        q4=p(:,3)+p(:,4)
       end if
       sqsu3=ecm-sqsl4
       call mapbkk(imom,x(3),q3,mh,gamh,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-sqsl1
       call mapbkk(imom,x(2),q2,mw,gamw,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs3-sqs2
       call mapbkk(imom,x(1),q1,mw,gamw,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs3
       call mapbkk(imom,x(4),q4,mz,gamz,sqsl4,sqsu4,s4,sqs4,ds4)
       call kinff(imom,sqs1,m(6),m(5),x(5:6),p(:,6),p(:,5),dl1)
       call kinff(imom,sqs2,m(7),m(8),x(7:8),p(:,7),p(:,8),dl2)
       call kinff(imom,sqs3,sqs1,sqs2,x(9:10),q1,q2,dl3)
       call kinff(imom,sqs4,m(3),m(4),x(11:12),p(:,3),p(:,4),dl4)
       call kinff(imom,ecm,sqs3,sqs4,x(13:14),q3,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,5))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
       end if
      else if (ikin == 30) then
       sqsl1=m(6)+m(5)
       sqsl2=m(7)+m(8)
       sqsl3=sqsl1+sqsl2
       sqsl4=m(3)+m(4)
       if (imom /= 1) then
        q1=p(:,6)+p(:,5)
        q2=p(:,7)+p(:,8)
        q3=q1+q2
        q4=p(:,3)+p(:,4)
       end if
       sqsu3=ecm-sqsl4
       call mapbkk(imom,x(3),q3,mh,gamh,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-sqsl1
       call mapbkk(imom,x(2),q2,mw,gamw,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs3-sqs2
       call mapbkk(imom,x(1),q1,mw,gamw,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs3
       call mapbkk(imom,x(4),q4,mh,gamh,sqsl4,sqsu4,s4,sqs4,ds4)
       call kinff(imom,sqs1,m(6),m(5),x(5:6),p(:,6),p(:,5),dl1)
       call kinff(imom,sqs2,m(7),m(8),x(7:8),p(:,7),p(:,8),dl2)
       call kinff(imom,sqs3,sqs1,sqs2,x(9:10),q1,q2,dl3)
       call kinff(imom,sqs4,m(3),m(4),x(11:12),p(:,3),p(:,4),dl4)
       call kinff(imom,ecm,sqs3,sqs4,x(13:14),q3,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,5))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
       end if
      else if (ikin == 31) then
       sqsl1=m(6)+m(5)
       sqsl2=m(7)+sqsl1
       sqsl3=sqsl2+m(8)
       sqsl4=m(3)+m(4)
       if (imom /= 1) then
        q1=p(:,6)+p(:,5)
        q2=p(:,7)+q1
        q3=q2+p(:,8)
        q4=p(:,3)+p(:,4)
       end if
       sqsu3=ecm-sqsl4
       call mapakk(imom,x(3),q3,sqscut,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(8)
       call mapbkk(imom,x(2),q2,mu,gamu,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(7)
       call mapbkk(imom,x(1),q1,mw,gamw,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs3
       call mapakk(imom,x(4),q4,sqscut,sqsl4,sqsu4,s4,sqs4,ds4)
       call kinff(imom,sqs1,m(6),m(5),x(5:6),p(:,6),p(:,5),dl1)
       call kinff(imom,sqs2,m(7),sqs1,x(7:8),p(:,7),q1,dl2)
       call kinff(imom,sqs3,sqs2,m(8),x(9:10),q2,p(:,8),dl3)
       call kinff(imom,sqs4,m(3),m(4),x(11:12),p(:,3),p(:,4),dl4)
       call kinff(imom,ecm,sqs3,sqs4,x(13:14),q3,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,5))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,5))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,8))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
       end if
      else if (ikin == 32) then
       sqsl1=m(6)+m(5)
       sqsl2=m(7)+sqsl1
       sqsl3=sqsl2+m(8)
       sqsl4=m(3)+m(4)
       if (imom /= 1) then
        q1=p(:,6)+p(:,5)
        q2=p(:,7)+q1
        q3=q2+p(:,8)
        q4=p(:,3)+p(:,4)
       end if
       sqsu3=ecm-sqsl4
       call mapakk(imom,x(3),q3,sqscut,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(8)
       call mapbkk(imom,x(2),q2,mu,gamu,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(7)
       call mapbkk(imom,x(1),q1,mw,gamw,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs3
       call mapbkk(imom,x(4),q4,mz,gamz,sqsl4,sqsu4,s4,sqs4,ds4)
       call kinff(imom,sqs1,m(6),m(5),x(5:6),p(:,6),p(:,5),dl1)
       call kinff(imom,sqs2,m(7),sqs1,x(7:8),p(:,7),q1,dl2)
       call kinff(imom,sqs3,sqs2,m(8),x(9:10),q2,p(:,8),dl3)
       call kinff(imom,sqs4,m(3),m(4),x(11:12),p(:,3),p(:,4),dl4)
       call kinff(imom,ecm,sqs3,sqs4,x(13:14),q3,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,5))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,5))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,8))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
       end if
      else if (ikin == 33) then
       sqsl1=m(6)+m(5)
       sqsl2=m(7)+sqsl1
       sqsl3=sqsl2+m(8)
       sqsl4=m(3)+m(4)
       if (imom /= 1) then
        q1=p(:,6)+p(:,5)
        q2=p(:,7)+q1
        q3=q2+p(:,8)
        q4=p(:,3)+p(:,4)
       end if
       sqsu3=ecm-sqsl4
       call mapakk(imom,x(3),q3,sqscut,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(8)
       call mapbkk(imom,x(2),q2,mu,gamu,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(7)
       call mapbkk(imom,x(1),q1,mw,gamw,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs3
       call mapbkk(imom,x(4),q4,mh,gamh,sqsl4,sqsu4,s4,sqs4,ds4)
       call kinff(imom,sqs1,m(6),m(5),x(5:6),p(:,6),p(:,5),dl1)
       call kinff(imom,sqs2,m(7),sqs1,x(7:8),p(:,7),q1,dl2)
       call kinff(imom,sqs3,sqs2,m(8),x(9:10),q2,p(:,8),dl3)
       call kinff(imom,sqs4,m(3),m(4),x(11:12),p(:,3),p(:,4),dl4)
       call kinff(imom,ecm,sqs3,sqs4,x(13:14),q3,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,5))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,5))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,8))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
       end if
      else if (ikin == 34) then
       sqsl1=m(6)+m(5)
       sqsl2=m(7)+sqsl1
       sqsl3=sqsl2+m(8)
       sqsl4=m(3)+m(4)
       if (imom /= 1) then
        q1=p(:,6)+p(:,5)
        q2=p(:,7)+q1
        q3=q2+p(:,8)
        q4=p(:,3)+p(:,4)
       end if
       sqsu3=ecm-sqsl4
       call mapbkk(imom,x(3),q3,mz,gamz,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(8)
       call mapbkk(imom,x(2),q2,mu,gamu,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(7)
       call mapbkk(imom,x(1),q1,mw,gamw,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs3
       call mapakk(imom,x(4),q4,sqscut,sqsl4,sqsu4,s4,sqs4,ds4)
       call kinff(imom,sqs1,m(6),m(5),x(5:6),p(:,6),p(:,5),dl1)
       call kinff(imom,sqs2,m(7),sqs1,x(7:8),p(:,7),q1,dl2)
       call kinff(imom,sqs3,sqs2,m(8),x(9:10),q2,p(:,8),dl3)
       call kinff(imom,sqs4,m(3),m(4),x(11:12),p(:,3),p(:,4),dl4)
       call kinff(imom,ecm,sqs3,sqs4,x(13:14),q3,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,5))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,5))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,8))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
       end if
      else if (ikin == 35) then
       sqsl1=m(6)+m(5)
       sqsl2=m(7)+sqsl1
       sqsl3=sqsl2+m(8)
       sqsl4=m(3)+m(4)
       if (imom /= 1) then
        q1=p(:,6)+p(:,5)
        q2=p(:,7)+q1
        q3=q2+p(:,8)
        q4=p(:,3)+p(:,4)
       end if
       sqsu3=ecm-sqsl4
       call mapbkk(imom,x(3),q3,mz,gamz,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(8)
       call mapbkk(imom,x(2),q2,mu,gamu,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(7)
       call mapbkk(imom,x(1),q1,mw,gamw,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs3
       call mapbkk(imom,x(4),q4,mz,gamz,sqsl4,sqsu4,s4,sqs4,ds4)
       call kinff(imom,sqs1,m(6),m(5),x(5:6),p(:,6),p(:,5),dl1)
       call kinff(imom,sqs2,m(7),sqs1,x(7:8),p(:,7),q1,dl2)
       call kinff(imom,sqs3,sqs2,m(8),x(9:10),q2,p(:,8),dl3)
       call kinff(imom,sqs4,m(3),m(4),x(11:12),p(:,3),p(:,4),dl4)
       call kinff(imom,ecm,sqs3,sqs4,x(13:14),q3,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,5))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,5))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,8))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
       end if
      else if (ikin == 36) then
       sqsl1=m(6)+m(5)
       sqsl2=m(7)+sqsl1
       sqsl3=sqsl2+m(8)
       sqsl4=m(3)+m(4)
       if (imom /= 1) then
        q1=p(:,6)+p(:,5)
        q2=p(:,7)+q1
        q3=q2+p(:,8)
        q4=p(:,3)+p(:,4)
       end if
       sqsu3=ecm-sqsl4
       call mapbkk(imom,x(3),q3,mz,gamz,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(8)
       call mapbkk(imom,x(2),q2,mu,gamu,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(7)
       call mapbkk(imom,x(1),q1,mw,gamw,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs3
       call mapbkk(imom,x(4),q4,mh,gamh,sqsl4,sqsu4,s4,sqs4,ds4)
       call kinff(imom,sqs1,m(6),m(5),x(5:6),p(:,6),p(:,5),dl1)
       call kinff(imom,sqs2,m(7),sqs1,x(7:8),p(:,7),q1,dl2)
       call kinff(imom,sqs3,sqs2,m(8),x(9:10),q2,p(:,8),dl3)
       call kinff(imom,sqs4,m(3),m(4),x(11:12),p(:,3),p(:,4),dl4)
       call kinff(imom,ecm,sqs3,sqs4,x(13:14),q3,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,5))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,5))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,8))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
       end if
      else if (ikin == 37) then
       sqsl1=m(6)+m(5)
       sqsl2=m(7)+sqsl1
       sqsl3=sqsl2+m(8)
       sqsl4=m(3)+m(4)
       if (imom /= 1) then
        q1=p(:,6)+p(:,5)
        q2=p(:,7)+q1
        q3=q2+p(:,8)
        q4=p(:,3)+p(:,4)
       end if
       sqsu3=ecm-sqsl4
       call mapbkk(imom,x(3),q3,mh,gamh,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(8)
       call mapbkk(imom,x(2),q2,mu,gamu,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(7)
       call mapbkk(imom,x(1),q1,mw,gamw,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs3
       call mapakk(imom,x(4),q4,sqscut,sqsl4,sqsu4,s4,sqs4,ds4)
       call kinff(imom,sqs1,m(6),m(5),x(5:6),p(:,6),p(:,5),dl1)
       call kinff(imom,sqs2,m(7),sqs1,x(7:8),p(:,7),q1,dl2)
       call kinff(imom,sqs3,sqs2,m(8),x(9:10),q2,p(:,8),dl3)
       call kinff(imom,sqs4,m(3),m(4),x(11:12),p(:,3),p(:,4),dl4)
       call kinff(imom,ecm,sqs3,sqs4,x(13:14),q3,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,5))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,5))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,8))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
       end if
      else if (ikin == 38) then
       sqsl1=m(6)+m(5)
       sqsl2=m(7)+sqsl1
       sqsl3=sqsl2+m(8)
       sqsl4=m(3)+m(4)
       if (imom /= 1) then
        q1=p(:,6)+p(:,5)
        q2=p(:,7)+q1
        q3=q2+p(:,8)
        q4=p(:,3)+p(:,4)
       end if
       sqsu3=ecm-sqsl4
       call mapbkk(imom,x(3),q3,mh,gamh,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(8)
       call mapbkk(imom,x(2),q2,mu,gamu,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(7)
       call mapbkk(imom,x(1),q1,mw,gamw,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs3
       call mapbkk(imom,x(4),q4,mz,gamz,sqsl4,sqsu4,s4,sqs4,ds4)
       call kinff(imom,sqs1,m(6),m(5),x(5:6),p(:,6),p(:,5),dl1)
       call kinff(imom,sqs2,m(7),sqs1,x(7:8),p(:,7),q1,dl2)
       call kinff(imom,sqs3,sqs2,m(8),x(9:10),q2,p(:,8),dl3)
       call kinff(imom,sqs4,m(3),m(4),x(11:12),p(:,3),p(:,4),dl4)
       call kinff(imom,ecm,sqs3,sqs4,x(13:14),q3,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,5))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,5))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,8))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
       end if
      else if (ikin == 39) then
       sqsl1=m(6)+m(5)
       sqsl2=m(7)+sqsl1
       sqsl3=sqsl2+m(8)
       sqsl4=m(3)+m(4)
       if (imom /= 1) then
        q1=p(:,6)+p(:,5)
        q2=p(:,7)+q1
        q3=q2+p(:,8)
        q4=p(:,3)+p(:,4)
       end if
       sqsu3=ecm-sqsl4
       call mapbkk(imom,x(3),q3,mh,gamh,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(8)
       call mapbkk(imom,x(2),q2,mu,gamu,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(7)
       call mapbkk(imom,x(1),q1,mw,gamw,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs3
       call mapbkk(imom,x(4),q4,mh,gamh,sqsl4,sqsu4,s4,sqs4,ds4)
       call kinff(imom,sqs1,m(6),m(5),x(5:6),p(:,6),p(:,5),dl1)
       call kinff(imom,sqs2,m(7),sqs1,x(7:8),p(:,7),q1,dl2)
       call kinff(imom,sqs3,sqs2,m(8),x(9:10),q2,p(:,8),dl3)
       call kinff(imom,sqs4,m(3),m(4),x(11:12),p(:,3),p(:,4),dl4)
       call kinff(imom,ecm,sqs3,sqs4,x(13:14),q3,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,5))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,5))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,8))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
       end if
      else if (ikin == 40) then
       sqsl1=m(6)+m(5)
       sqsl2=m(7)+m(8)
       sqsl3=sqsl1+sqsl2
       sqsl4=m(3)+m(4)
       if (imom /= 1) then
        q1=p(:,6)+p(:,5)
        q2=p(:,7)+p(:,8)
        q3=q1+q2
        q4=p(:,3)+p(:,4)
       end if
       sqsu3=ecm-sqsl4
       ds3=(sqsu3-sqsl3)*(sqsu3+sqsl3)
       if (imom == 1) then
        s3=ds3*x(3)+sqsl3*sqsl3
       else
        s3=(q3(0)-q3(3))*(q3(0)+q3(3))-q3(1)*q3(1)-q3(2)*q3(2)
       end if
       sqs3=sqrt(s3)
       sqsu2=sqs3-sqsl1
       call mapbkk(imom,x(2),q2,mw,gamw,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs3-sqs2
       call mapbkk(imom,x(1),q1,mw,gamw,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs3
       call mapakk(imom,x(4),q4,sqscut,sqsl4,sqsu4,s4,sqs4,ds4)
       call kinff(imom,sqs1,m(6),m(5),x(5:6),p(:,6),p(:,5),dl1)
       call kinff(imom,sqs2,m(7),m(8),x(7:8),p(:,7),p(:,8),dl2)
       call kinff(imom,sqs3,sqs1,sqs2,x(9:10),q1,q2,dl3)
       call kinff(imom,sqs4,m(3),m(4),x(11:12),p(:,3),p(:,4),dl4)
       call kinff(imom,ecm,sqs3,sqs4,x(13:14),q3,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,5))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
       end if
      end if
 
      end
